/************** BEST VIEWED IN A CODE EDITOR 80 COLUMNS WIDE *******************
*
* US General Labels
* Benjamen Johnson <3dprints.electronsmith.com>
* 20201209
*
* openSCAD Version: 2019.05 
* Licesnse: Creative Commons - Attribution - Share Alike
*           https://creativecommons.org/licenses/by-sa/4.0/
*******************************************************************************/
/*[Hidden]*/
version="V1.0";

/*[Label Options]*/
/*******************************************************************************
* Label Options
*******************************************************************************/
// Enter the text you want to display
label = "SCREWDRIVER";

// Enter the length of the label
base_length = 100; //[20:300]

// Angle of the label off the vertical access
label_angle = 20; //[0:5:30]

/*[Font Options]*/
/*******************************************************************************
* Font Options
*******************************************************************************/
// Which font do you want to use
font = "Ariel";

// How big you want the text
font_size = 12;//[0:0.5:14]

// How thick the font is (back to front)
font_thickness = 1;

/*[Advanced Parameters]*/
/*******************************************************************************
* Advanced Parameters
*******************************************************************************/
// Height of the base (top to bottom)
base_height = 16.9;

// How thick to make the base
base_thickness = 1.5;

// How thick to make the sub-base how far it sticks out of the extrusion
pedistal_thickness = 1.5;

// height of the pedistal (top to bottom)
pedistal_height = 14;

/*[Hidden]*/
$dl = 0.05;

//how thick to make the angled base
angled_plate_thickness = pedistal_height*tan(label_angle);

/*******************************************************************************
* Do it
*******************************************************************************/
rotate([label_angle,0,0])
union(){
    translate([0,base_height/2,0])
    difference(){
        union(){
            // Make base
            translate([0,0,base_thickness/2])
            color("red")
            cube([base_length,base_height,base_thickness], center=true);
            
            // Make pedistal
            translate([0,0,base_thickness+pedistal_thickness/2])
            color("red")
            cube([base_length,pedistal_height,pedistal_thickness], center=true);
            
            // Make angled plate
            translate([0,0,base_thickness+pedistal_thickness+angled_plate_thickness/2])
            color("red")
            cube([base_length,pedistal_height,angled_plate_thickness], center=true);
        }
        
        translate([0,7,base_thickness+pedistal_thickness])
        rotate([-label_angle,0,0])
        translate([0,-base_height/2,angled_plate_thickness/2])
        cube([base_length+$dl,base_height,angled_plate_thickness], center=true);
    } //end difference

    // make some text position calculations
    y_offset = (base_height-pedistal_height)/2;
    text_y_pos =(pedistal_height/cos(label_angle)-font_size)/2;
    text_z_pos = -text_y_pos*tan(label_angle);

    // make the text
    translate([0,y_offset+text_y_pos,base_thickness+pedistal_thickness+angled_plate_thickness+text_z_pos])    
    color("white")
    rotate([-label_angle,0,0])
    linear_extrude(height = font_thickness)
        text(text = label, font = font, size = font_size, halign = "center");
}// end union
